/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// AuthorizationStatus the model 'AuthorizationStatus'
type AuthorizationStatus string

// List of AuthorizationStatus
const (
	AUTHORIZATIONSTATUS_AUTHORIZED        AuthorizationStatus = "Authorized"
	AUTHORIZATIONSTATUS_APPROVAL_REQUIRED AuthorizationStatus = "ApprovalRequired"
	AUTHORIZATIONSTATUS_DENIED            AuthorizationStatus = "Denied"
)

// All allowed values of AuthorizationStatus enum
var AllowedAuthorizationStatusEnumValues = []AuthorizationStatus{
	"Authorized",
	"ApprovalRequired",
	"Denied",
}

func (v *AuthorizationStatus) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := AuthorizationStatus(value)
	for _, existing := range AllowedAuthorizationStatusEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid AuthorizationStatus", value)
}

// NewAuthorizationStatusFromValue returns a pointer to a valid AuthorizationStatus
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewAuthorizationStatusFromValue(v string) (*AuthorizationStatus, error) {
	ev := AuthorizationStatus(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for AuthorizationStatus: valid values are %v", v, AllowedAuthorizationStatusEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v AuthorizationStatus) IsValid() bool {
	for _, existing := range AllowedAuthorizationStatusEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to AuthorizationStatus value
func (v AuthorizationStatus) Ptr() *AuthorizationStatus {
	return &v
}

type NullableAuthorizationStatus struct {
	value *AuthorizationStatus
	isSet bool
}

func (v NullableAuthorizationStatus) Get() *AuthorizationStatus {
	return v.value
}

func (v *NullableAuthorizationStatus) Set(val *AuthorizationStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableAuthorizationStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableAuthorizationStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuthorizationStatus(val *AuthorizationStatus) *NullableAuthorizationStatus {
	return &NullableAuthorizationStatus{value: val, isSet: true}
}

func (v NullableAuthorizationStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuthorizationStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
